from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals


class Error(Exception):
    pass


class ConfigError(Error):
    pass


class NotReadyConfigError(ConfigError):
    pass


class EnumConfigError(ConfigError):
    pass


class ConsistencyError(Error):
    def __init__(self):
        super(ConsistencyError, self).__init__()
        self.status_message = None


class ExternalNetworkNameChangeError(ConfigError):
    def __init__(self):
        super(ExternalNetworkNameChangeError, self).__init__()
        self.status_message = (
            'Config inconsistent: '
            'cannot change "external-network-name" once deployed'
        )


class MultipleUnitStaticRoutingError(ConfigError):
    def __init__(self):
        super(MultipleUnitStaticRoutingError, self).__init__()
        self.status_message = (
            'Config inconsistent: '
            'cannot deploy more than one unit if "uplink-type" is "static"'
        )


class PortGroupNameChangeError(ConfigError):
    def __init__(self):
        super(PortGroupNameChangeError, self).__init__()
        self.status_message = (
            'Config inconsistent: '
            'cannot change "port-group-name" once deployed'
        )
