from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

import charmhelpers.core.hookenv

SERVICE_MANAGER_START_CALLBACK_BEGIN = (
    'Start (re)configuring charm'
)
SERVICE_MANAGER_START_CALLBACK_REQUIRED_DATA = (
    'Setting up required data'
)
SERVICE_MANAGER_START_CALLBACK_API_CLIENTS = (
    'Setting up API clients'
)
SERVICE_MANAGER_CALLBACK_TEARDOWN_STATIC = (
    'Tearing down old static routing configuration'
)
SERVICE_MANAGER_CALLBACK_TEARDOWN_BGP = (
    'Tearing down old BGP routing configuration'
)
SERVICE_MANAGER_CALLBACK_SETUP_STATIC = (
    'Configuring MidoNet gateway with static routing'
)
SERVICE_MANAGER_CALLBACK_SETUP_BGP = (
    'Configuring MidoNet gateway with BGP routing'
)
SERVICE_MANAGER_START_CALLBACK_FINISHED = (
    'Unit is ready'
)

HOST_IFUP = (
    'Brought up interface "{}" since it was down.'
)
HOST_IFDOWN = (
    'Brought down interface "{}" since it was up.'
)
HOST_FIX_INTERFACES_INCLUDE_START = (
    'Fixing "/etc/network/interfaces" to include '
    '"/etc/network/interfaces.d/*.cfg" if needed.'
)
HOST_FIX_INTERFACES_INCLUDE_SKIP = (
    'Not Fixing "/etc/network/interfaces" since it already includes '
    '"/etc/network/interfaces.d/*.cfg".'
)
HOST_FIX_INTERFACES_INCLUDE_FIXED = (
    'Fixed "/etc/network/interfaces" to include '
    '"/etc/network/interfaces.d/*.cfg".'
)
HOST_SETUP_VETH_PAIR_START = (
    'Configuring veth pair "{}" and "{}" to connect overlay to underlay.'
)
HOST_SETUP_VETH_PAIR_TEARDOWN = (
    'Removing veth pair "{}" and "{}" to connect overlay to underlay.'
)
HOST_SETUP_STATIC_BRIDGE_START = (
    'Configuring linux bridge for static routing setup.'
)
HOST_SETUP_STATIC_BRIDGE_TEARDOWN = (
    'Removing linux bridge for static routing setup.'
)
HOST_SETUP_MASQUERADING_NAT_RULE_FOUND = (
    'Found NAT rule in netfilter.'
)
HOST_SETUP_MASQUERADING_NAT_RULE_CREATED = (
    'Created NAT rule in netfilter.'
)
HOST_SETUP_MASQUERADING_NAT_RULE_DELETED = (
    'Deleted NAT rule in netfilter.'
)
HOST_SETUP_MASQUERADING_NAT_RULE_NOT_DELETED = (
    'Did not delete NAT rule in netfilter since it could not be found.'
)
HOST_SETUP_MASQUERADING_FORWARD_RULE_FOUND = (
    'Found forwarding rule in netfilter.'
)
HOST_SETUP_MASQUERADING_FORWARD_RULE_CREATED = (
    'Created forwarding rule in netfilter.'
)
HOST_SETUP_MASQUERADING_FORWARD_RULE_DELETED = (
    'Deleted forwarding rule in netfilter.'
)
HOST_SETUP_MASQUERADING_FORWARD_RULE_NOT_DELETED = (
    'Did not delete forwarding rule in netfilter since it could not be found.'
)

NEUTRON_EXTERNAL_NETWORK_CREATING = (
    'Creating neutron external network if necessary.'
)
NEUTRON_EXTERNAL_NETWORK_WAITING = (
    'Since this unit is not the leader, '
    'waiting neutron external network to be created.'
)
NEUTRON_EXTERNAL_NETWORK_FOUND = (
    'External network "{}" found with ID "{}".'
)
NEUTRON_EXTERNAL_NETWORK_NOT_FOUND = (
    'External network "{}" not found.'
)
NEUTRON_EXTERNAL_NETWORK_CREATED = (
    'Created external network "{}" with ID "{}".'
)

MIDONET_SETUP_STARTED_STATIC = (
    'Setting up midonet gateway in a static routing configuration.'
)
MIDONET_SETUP_STARTED_BGP = (
    'Setting up midonet gateway in a BGP routing configuration.'
)
MIDONET_SETUP_ERROR_PROVIDER_ROUTER_NOT_FOUND = (
    '"MidoNet Provider Router" not found. This should not be happening, and '
    'canoot continue at this time.'
)
MIDONET_PROVIDER_ROUTER_FOUND = (
    '"MidoNet Provider Router" found with ID "{}".'
)
MIDONET_PROVIDER_ROUTER_NOT_FOUND = (
    '"MidoNet Provider Router" not found.'
)
MIDONET_ROUTER_PORT_FOUND = (
    'Port with IP address "{}" and prefix length "{}" '
    'found with ID "{}" within router ID "{}".'
)
MIDONET_ROUTER_PORT_NOT_FOUND = (
    'Port with IP address "{}" and prefix length "{}" '
    'not found within router ID "{}".'
)
MIDONET_ROUTER_PORT_CREATED = (
    'Created port with IP address "{}" and prefix length "{}" '
    'with ID "{}" within router ID "{}".'
)
MIDONET_PORT_DELETED = (
    'Deleted Port with IP address "{}" and prefix length "{}" '
    'with ID "{}" within router ID "{}".'
)
MIDONET_PORT_BGP_FOUND = (
    'BGP configuration with local AS# "{}", peer address "{}" '
    'and peer AS# "{}" found with ID "{}" within port ID "{}".'
)
MIDONET_PORT_BGP_NOT_FOUND = (
    'BGP configuration with local AS# "{}", peer address "{}" '
    'and peer AS# "{}" not found within port ID "{}".'
)
MIDONET_PORT_BGP_CREATED = (
    'Created BGP configuration with local AS# "{}", peer address "{}" '
    'and peer AS# "{}" with ID "{}" within port ID "{}".'
)
MIDONET_BGP_AD_ROUTE_FOUND = (
    'AdRoute with network "{}" found with ID "{}" within Bgp ID "{}".'
)
MIDONET_BGP_AD_ROUTE_NOT_FOUND = (
    'AdRoute with network "{}" not found within Bgp ID "{}".'
)
MIDONET_BGP_AD_ROUTE_CREATED = (
    'Created AdRoute with network "{}" with ID "{}" within Bgp ID "{}".'
)
MIDONET_ROUTER_ROUTE_FOUND = (
    'Route with source network "{}", destination network "{}", next hop port '
    'ID "{}", next hop gateway address "{}", and route type "{}" found with '
    'ID "{}" within Router ID "{}".'
)
MIDONET_ROUTER_ROUTE_NOT_FOUND = (
    'Route with source network "{}", destination network "{}", next hop port '
    'ID "{}", next hop gateway address "{}", and route type "{}" not found '
    'within Router ID "{}".'
)
MIDONET_ROUTER_ROUTE_CREATED = (
    'Created Route with source network "{}", destination network "{}", next '
    'hop port ID "{}", next hop gateway adddress "{}", and route type "{}" '
    'with ID "{}" within Router ID "{}".'
)
MIDONET_ROUTE_DELETED = (
    'Deleted Route with source network "{}", destination network "{}", next '
    'hop port ID "{}", next hop gateway adddress "{}", and route type "{}" '
    'with ID "{}" within router ID "{}".'
)
MIDONET_HOST_FOUND = (
    'Host with ID "{}" found with hostname "{}".'
)
MIDONET_HOST_NOT_FOUND = (
    'Host with ID "{}" not found.'
)
MIDONET_HOST_IN_A_TZONE = (
    'Node with ID "{}" is in tunnel zone ID "{}".'
)
MIDONET_HOST_NOT_IN_ANY_TZONE = (
    'Node with ID "{}" is not in any tunnel zone.'
)
MIDONET_HOST_INTERFACE_PORT_FOUND = (
    'Port with ID "{}" is already bound with interface "{}".'
)
MIDONET_HOST_INTERFACE_PORT_NOT_FOUND = (
    'Port with ID "{}" is not bound with interface "{}".'
)
MIDONET_HOST_INTERFACE_PORT_CREATED = (
    'Bound Port ID "{}" with interface "{}" within host ID "{}".'
)
MIDONET_HOST_INTERFACE_PORT_DELETED = (
    'Unbound Port ID "{}" with interface "{}" within host ID "{}".'
)
MIDONET_PORT_GROUP_FOUND = (
    'Stateful port group with name "{}" found with ID "{}".'
)
MIDONET_PORT_GROUP_NOT_FOUND = (
    'Stateful port group with name "{}" not found.'
)
MIDONET_PORT_GROUP_CREATED = (
    'Created stateful port group with name "{}" with ID "{}".'
)
MIDONET_PORT_GROUP_NOT_DELETED = (
    'Not deleting PortGroup with name "{}" and ID "{}" since it is not empty.'
)
MIDONET_PORT_GROUP_DELETED = (
    'Deleted PortGroup with name "{}" and ID "{}".'
)
MIDONET_PORT_GROUP_PORT_FOUND = (
    'PortGroupPort with Port ID "{}" found within PortGroup ID "{}".'
)
MIDONET_PORT_GROUP_PORT_NOT_FOUND = (
    'PortGroupPort with Port ID "{}" not found within PortGroup ID "{}".'
)
MIDONET_PORT_GROUP_PORT_CREATED = (
    'Created PortGroupPort with Port ID "{}" within PortGroup ID "{}".'
)
MIDONET_PORT_GROUP_PORT_DELETED = (
    'Deleted PortGroupPort with Port ID "{}" within PortGroup ID "{}".'
)


def debug(message):
    charmhelpers.core.hookenv.log(message, charmhelpers.core.hookenv.DEBUG)


def info_with_status(status, message):
    charmhelpers.core.hookenv.log(message, charmhelpers.core.hookenv.INFO)
    charmhelpers.core.hookenv.status_set(status, message)


def error(message):
    charmhelpers.core.hookenv.log(message, charmhelpers.core.hookenv.ERROR)


def error_with_status(status, message):
    charmhelpers.core.hookenv.log(message, charmhelpers.core.hookenv.ERROR)
    charmhelpers.core.hookenv.status_set(status, message)
