from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

import charmhelpers.core.hookenv

import lib.log
import lib.neutron_api


def create_neutron_external_network(neutronclient, rd_config):
    if charmhelpers.core.hookenv.is_leader():
        lib.log.debug(
            lib.log.NEUTRON_EXTERNAL_NETWORK_CREATING
        )
        external_network = lib.neutron_api.create_external_network(
            neutron_client=neutronclient,
            external_network_name=rd_config['external-network-name'],
        )
    else:
        lib.log.debug(
            lib.log.NEUTRON_EXTERNAL_NETWORK_WAITING
        )
        external_network = lib.neutron_api.get_existing_external_network(
            neutron_client=neutronclient,
            external_network_name=rd_config['external-network-name'],
        )

    return external_network
