from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

import copy


READY_STATIC = {
    'openstack-release': 'kilo',
    'midonet-release': '2015.06',
    'midonet-flavor': 'opensource',
    'midonet-enterprise-username': '',
    'midonet-enterprise-password': '',
    'external-network-name': 'some-external-network',
    'uplink-type': 'static',
    'static-linux-bridge-address': '192.0.2.1/30',
    'static-provider-router-address': '192.0.2.2/30',
    'static-forwarding-network': '10.20.30.0/24',
    'static-outgoing-masquerade': True,
    'static-outgoing-interface-name': 'outgoing-interface-name'
}

READY_BGP = {
    'openstack-release': 'kilo',
    'midonet-release': '2015.06',
    'midonet-flavor': 'enterprise',
    'midonet-enterprise-username': 'username',
    'midonet-enterprise-password': 'password',
    'external-network-name': 'some-external-network',
    'uplink-type': 'bgp',
    'bgp-local-interface-name': 'some-interface',
    'bgp-local-interface-mtu': 9000,
    'bgp-local-address': '192.0.2.1/30',
    'bgp-local-as-number': '65432',
    'bgp-peer-address': '192.0.2.2/30',
    'bgp-peer-as-number': '65456',
    'bgp-advertised-network': '10.20.30.0/24',
    'port-group-name': 'some-port-group'
}

NOT_READY = {
    'openstack-release': 'kilo',
    'midonet-release': '2015.06',
    'midonet-flavor': '',
    'midonet-enterprise-username': '',
    'midonet-enterprise-password': '',
    'external-network-name': 'ext-net',
    'uplink-type': '',
    'bgp-local-interface-name': '',
    'bgp-local-interface-mtu': 1500,
    'bgp-local-address': '',
    'bgp-local-as-number': '',
    'bgp-peer-address': '',
    'bgp-peer-as-number': '',
    'bgp-advertised-network': '',
    'port-group-name': 'uplink-spg',
}

NOT_READY_MISSING_MIDONET_FLAVOR = copy.deepcopy(READY_STATIC)
del NOT_READY_MISSING_MIDONET_FLAVOR['midonet-flavor']

NOT_READY_WRONG_MIDONET_FLAVOR = copy.deepcopy(READY_STATIC)
NOT_READY_WRONG_MIDONET_FLAVOR['midonet-flavor'] = 'foo'

NOT_READY_MISSING_UPLINK_TYPE = copy.deepcopy(READY_STATIC)
del NOT_READY_MISSING_UPLINK_TYPE['uplink-type']

NOT_READY_WRONG_UPLINK_TYPE = copy.deepcopy(READY_STATIC)
NOT_READY_WRONG_UPLINK_TYPE['uplink-type'] = 'foo'

NOT_READY_ENTERPRISE_NO_USERNAME = copy.deepcopy(READY_STATIC)
NOT_READY_ENTERPRISE_NO_USERNAME['midonet-flavor'] = 'enterprise'
NOT_READY_ENTERPRISE_NO_USERNAME['midonet-enterprise-username'] = ''

NOT_READY_ENTERPRISE_NO_PASSWORD = copy.deepcopy(READY_STATIC)
NOT_READY_ENTERPRISE_NO_PASSWORD['midonet-flavor'] = 'enterprise'
NOT_READY_ENTERPRISE_NO_PASSWORD['midonet-enterprise-password'] = ''

NOT_READY_MISSING_STATIC_KEY = copy.deepcopy(READY_STATIC)
NOT_READY_MISSING_STATIC_KEY['uplink-type'] = 'static'
del NOT_READY_MISSING_STATIC_KEY['static-linux-bridge-address']

NOT_READY_MISSING_STATIC_VALUE = copy.deepcopy(READY_STATIC)
NOT_READY_MISSING_STATIC_VALUE['uplink-type'] = 'static'
NOT_READY_MISSING_STATIC_VALUE['static-linux-bridge-address'] = ''

NOT_READY_MISSING_STATIC_MASQ_KEY = copy.deepcopy(READY_STATIC)
NOT_READY_MISSING_STATIC_MASQ_KEY['uplink-type'] = 'static'
NOT_READY_MISSING_STATIC_MASQ_KEY['static-outgoing-masquerade'] = True
del NOT_READY_MISSING_STATIC_MASQ_KEY['static-outgoing-interface-name']

NOT_READY_MISSING_STATIC_MASQ_VALUE = copy.deepcopy(READY_STATIC)
NOT_READY_MISSING_STATIC_MASQ_VALUE['uplink-type'] = 'static'
NOT_READY_MISSING_STATIC_MASQ_VALUE['static-outgoing-masquerade'] = True
NOT_READY_MISSING_STATIC_MASQ_VALUE['static-outgoing-interface-name'] = ''
